<!DOCTYPE html>
<html>
<head>
	<title></title>
</head>
<body>
	<style type="text/css">
		body{
			margin:0;
			font-family: "Poppins", sans-serif;
		}
		nav{
			background:coral;
			color:white;
			box-shadow: 0 2px 8px rgba(0,0,0,0.1);
			height:8vh;
			align-items: center;
			padding:0 5vw;
			box-sizing: border-box;
			display: flex;
			justify-content: center;
		}
		section{
			background:rgba(0,0,0,.03);
			height:92vh;
			width: 100%;
			display: flex;
		}
		.form-area,.list-area{
			height:100%;
			width: 50%;
			display: flex;
			flex-direction: column;
		}
		.add-mode>.edit-form{
			display: none;
		}
		.edit-mode>.add-form{
			display: none;
		}
		.add-form,.edit-form{
			background:white;
			display: flex;
			flex-direction: column;
			box-shadow: 0 2px 8px rgba(0,0,0,.12);

			border-radius:5px;
			padding:16px;
			border:1px solid rgba(0,0,0,0.2);
		}
		.form-area{
			padding:0 5vw;
			box-sizing: border-box;			
		}
		input{
			margin:10px 0;
			border:none;
			border-bottom:1px solid coral;
			padding:10px 15px;
		}
		input:focus{
			outline: none;
			border-bottom-width: 2px;
		}
		 button{
		 	padding:10px 25px;
		 	color:coral;
		 	font-weight: bolder;
		 	background:transparent;
		 	cursor: pointer;
		 	border-radius: 5px;
		 	border:1px solid coral;
		 }
		 button:hover{
		 	background:coral;
		 	color:white;
		 }
		 .list-area{
		 	overflow-y: auto;
		 }
		 .list-area>h2{
		 	position: sticky;
		 	top:0vh;
		 	/*background:white;*/
		 	z-index: 10;
		 }
		 .list-of-items{
		 	display:flex;
		 	flex-wrap: wrap;
		 }
		.item{
			background:white;
			text-align: center;
			box-shadow: 0 2px 8px rgba(0,0,0,.12);		
			margin:3px;
			height:200px;
			width: 200px;
			border:1px solid rgba(0,0,0,0.2);
			border-radius: 5px;
			display:flex;
			padding:8px;
			box-sizing: border-box;
			justify-content: center;
			align-items: center;
			position: relative;
			flex-direction: column;
		}
		.item>u{
			cursor: pointer;
			font-size:.8rem;
		}
		.item-id{
			position: absolute;
			top:8px;
			left: 8px;
			height:35px;
			width: 35px;
			background:coral;
			display: flex;
			justify-content: center;
			align-items: center;
			color: white;
			font-weight: bold;
			border-radius: 50%;
		}
		.close{
			right:8px;
			top:10px;
			cursor:pointer;
			height:15px;
			width: 15px;
			font-weight: bolder;
			font-size:1.2rem;
			display:flex;
			/*border:1px solid white;*/
			border-radius: 50%;
			justify-content: center;
			align-items: center;
			color:coral;
			position: absolute;
		}
		#backdrop{
			animation: .3s appear ease-in;
			top:0;
			height:100vh;
			width: 100%;
			background:rgba(0,0,0,0.8);
			position: fixed;
		}

		#descriptionCard{
			background:white;
			height:30vh;
			width: 40vw;
			border:1px solid rgba(0,0,0,.9);
			border-radius: 5px;
			position: fixed;
			transition: .5s;
			display: flex;
			text-align: center;
			flex-direction: column;
			left:30vw;
		}
		.appear{
			top:30vh;
		}
		.disappear{
			top:-50vh;
		}
		.block{
			display: block;
		}
		.none{
			display: none;
		}
		@keyframes appear{
			from{
				opacity: 0
			}to{
				opacity: 1
			}
		}
	</style>
<nav>
	<h1>To do</h1>
</nav>
<section>
	<div class="form-area add-mode" id="formArea">
		<h2>Form </h2>
		<div class="add-form">
			<h2>Add an item</h2>
			<input type="text" id="title" placeholder="Enter a title">
			<input type="text" id="description" placeholder="Enter a description">
			<div class="button-area">
				<button onclick="addItem()">Add</button>
				<button onclick="toggleForm();">Edit</button>
			</div>
		</div>

		<div class="edit-form">
			<h2>Edit an item</h2>
			<input type="text" id="todoId" placeholder="Enter an Id">
			<input type="text" id="newtitle" placeholder="Enter New Title">
			<input type="text" id="newdescription" placeholder="Enter new Description">
			<div class="button-area">
				<button onclick="editItem()">Save</button>
				<button onclick="toggleForm()">Cancel</button>
			</div>
		</div>
	</div>
	<div class="list-area">
		<h2>Todo List</h2>
		<div class="list-of-items"></div>
	</div>
</section>
<div id="backdrop" onclick="toggleDialog()" class="none"></div>
<div id="descriptionCard" class="disappear">
	
</div>
</body>
<script type="text/javascript">
	var listOfItems=[
		{id:1, title:'this', description:'this is it'},
		{id:2, title:'this', description:'this is it'},
		{id:3, title:'this', description:'this is it'},
		{id:4, title:'this', description:'this is it'},
	];
	displayList();
	let todo={
		id:0,
		title:'',
		description:''
	};
	[document.querySelector('#description'),document.querySelector('#title')].forEach(input=>input.addEventListener('keyup',(e)=>{
		e.key=='Enter'?addItem():false;
	}));
	function addItem(){
		// console.log(listOfItems.length);
		todo.id=listOfItems[listOfItems.length-1].id+1;
		todo.title=document.getElementById('title').value;
		todo.description=document.getElementById('description').value;
		if(todo.title !=='' || todo.description !==''){
		let insert= {...todo};
		listOfItems.push(insert);
		displayList();
		}
	}
	function displayList(){
		document.querySelector('.list-of-items').innerHTML='';
		listOfItems.forEach(function (item){
			document.querySelector('.list-of-items').innerHTML+= 
			`<div class="item">
				<span class="close" onclick="deleteItem(${item.id})">X</span>
				<span class="item-id">${item.id}. </span>
				<h3 class="item-title">${item.title}</h3>
				<u onclick="showDescription(${item.id})">Read More</u>
			</div>`;
		});
	}
	function toggleForm(){
		document.querySelector('.form-area').classList.toggle('add-mode');
		document.querySelector('.form-area').classList.toggle('edit-mode');
	}

	function deleteItem(id){
		console.log(id);
		listOfItems= listOfItems.filter(function (item){
			return item.id!==id});
		displayList();
	}
	function editItem(){
		let id=document.querySelector('#todoId').value;
		if(id!=''){
		let newTitle=document.querySelector('#newtitle').value;
		let newdescription=document.querySelector('#newdescription').value;
		let index=listOfItems.findIndex((item)=>item.id==parseInt(id));
		listOfItems[index]={
			...listOfItems[index],
			title:newTitle!=''?newTitle:listOfItems[index].title, 
			description:newdescription!=''?newTitle:listOfItems[index].description, 
			};
		displayList();
		}
	}

	function showDescription(id, item=findTask(id)){
		document.querySelector('#descriptionCard').innerHTML=`
		<h2>${item.id}. ${item.title}</h2>
		<p>${item.description==''?"No Description": item.description}</p>
		<div class="button-area">
			<button onclick="toggleDialog()">OK</button>
		</div>`;
		toggleDialog();
	}

	function toggleDialog(){
		document.querySelector('#backdrop').classList.toggle('block');
		document.querySelector('#backdrop').classList.toggle('none');
		document.querySelector('#descriptionCard').classList.toggle('appear');	
		document.querySelector('#descriptionCard').classList.toggle('disappear');
	}
	function findTask(id){
		return listOfItems.find((item)=>item.id==id);
	}
</script>
</html>